use std::iter::Iterator;
use uuid::Uuid;

struct Counter {
    id: Uuid,
    counter: u128,
}

impl Counter {
    fn new() -> Self {
        Self {
            id: Uuid::new_v4(),
            counter: 0,
        }
    }
}

impl Iterator for Counter {
    type Item: Counter;

    fn next(&mut self) -> Option<Self::Item> {
        Counter::new()
    }
}

#[cfg(test)]
mod counters {
    use super::*;

    #[test]
    fn create_counter() {
        let count1 = Counter::new();
        let count2 = Counter::new();
        assert_ne!(count1.id, count2.id);
        assert_eq!(count1.counter, 0);
        assert_eq!(count2.counter, 0);
    }

    #[test]
    fn iterate_counter() {
        let count = Counter::new();
        let first = count.next().unwrap();
        let second = count.next().unwrap();
        let third = count.next().unwrap();
    }
}
